#ifndef CHROMEOS_PLATFORMS_CAMERA_LIBCAMERA_FACESSD_FACE_DETECTOR_CLIENT_CROS_WRAPPER_H_
#define CHROMEOS_PLATFORMS_CAMERA_LIBCAMERA_FACESSD_FACE_DETECTOR_CLIENT_CROS_WRAPPER_H_

#include <string>
#include <vector>

namespace human_sensing {

class FaceDetectorTfliteClient;
class Faces;

// Face bounding box, pixels.
// (x1, y1): top left corner; (x2, y2): bottom right corner;
struct BoundingBox {
  float x1, y1, x2, y2;
};

struct CrosFace {
  BoundingBox bounding_box;
  // The confidence score should be in range [0.0, 1.0] and high score
  // indicates high confidence.
  float confidence;
};

class FaceDetectorClientCrosWrapper {
 public:
  FaceDetectorClientCrosWrapper();
  ~FaceDetectorClientCrosWrapper();

  // Returns true if initialize successfully.
  bool Initialize(
      const std::string& model_file, const std::string& anchor_file,
      float score_threshold);

  // Returns true if detecting faces successfully even there is no face.
  // |data| is the address of Y plane of YCbCr color space.
  bool Detect(
      const uint8_t* data, int width, int height,
      std::vector<CrosFace>* cros_faces);

 private:
  std::unique_ptr<FaceDetectorTfliteClient> client_;
};

}  // namespace human_sensing

#endif  // CHROMEOS_PLATFORMS_CAMERA_LIBCAMERA_FACESSD_FACE_DETECTOR_CLIENT_CROS_WRAPPER_H_
